<template>
  <div class="wp-card" :class="cardClasses">
    <div class="card-header">
      <div class="card-title">
        {{$props.title}}
      </div>
      <div class="card-header__actions" v-if="$props.edit">
        <font-awesome-icon icon="times" class="action-cancel" v-if="isEditing"
          @click="switchEditing()"/>
        <font-awesome-icon icon="pen" class="action-edit" v-else
          @click="switchEditing()"/>
      </div>
      <div class="card-header__actions" v-if="$props.delete">
        <font-awesome-icon icon="check" class="action-confirm" v-if="isDeleting"
          @click="$emit('delete')"/>
        <font-awesome-icon icon="times" class="action-cancel" v-if="isDeleting"
          @click="switchDeleting()"/>
        <font-awesome-icon icon="trash" class="action-delete" v-else
          @click="switchDeleting()"/>
      </div>
    </div>
    <card-menu v-if="$props.menuItems" v-model="activeMenu" :items="$props.menuItems"/>
    <div class="card-body">
      <slot name="default" :isCreating="isCreating" :isEditing="isEditing"/>
      <slot v-if="activeMenu" :name="activeMenu.prop"
        :isCreating="isCreating" :isEditing="isEditing"/>
    </div>
  </div>
</template>

<script>
import CardMenu from '@/components/card/CardMenu.vue';

export default {
  name: 'Card',
  components: {
    CardMenu,
  },
  provide() {
    return {
      switchCreating: this.switchCreating,
      switchEditing: this.switchEditing,
      switchDeleting: this.switchDeleting,
    };
  },
  data() {
    return {
      isCreating: false,
      isEditing: false,
      isDeleting: false,
      activeMenu: undefined,
    };
  },
  props: {
    title: {
      required: true,
      type: String,
    },
    edit: {
      type: Boolean,
      default: false,
    },
    delete: {
      type: Boolean,
      default: false,
    },
    menuItems: {
      type: Array,
      default: () => undefined,
    },
    data: {
      type: Object,
      default: () => undefined,
    },
  },
  computed: {
    cardClasses() {
      return {
        'wp-card--creating': this.isCreating,
        'wp-card--editing': this.isEditing,
        'wp-card--deleting': this.isDeleting,
      };
    },
  },
  methods: {
    switchCreating(isCreating = null) {
      if (!isCreating) this.isCreating = !this.isCreating;
      else this.isCreating = isCreating;
    },
    switchEditing(isEditing = null) {
      if (!isEditing) this.isEditing = !this.isEditing;
      else this.isEditing = isEditing;
    },
    switchDeleting(isDeleting = null) {
      if (!isDeleting) this.isDeleting = !this.isDeleting;
      else this.isDeleting = isDeleting;
    },
  },
  created() {
    if (this.$props.menuItems) {
      [this.activeMenu] = this.$props.menuItems;
    }
  },
};
</script>

<style lang="scss" scoped>
.wp-card {
  margin-bottom: 30px;
  width: $masonryColumnWidth;
  display: inline-block;
  min-height: 136px;
  border-radius: 10px;
  background: #fff;

  &--editing {

    .card-header {

      &__actions {

        .action-cancel {
          margin-right: 0;
          height: 20px;
        }

      }

    }

  }

  .card {

    &-header {
      box-sizing: content-box;
      padding: 0 20px;
      height: 60px;
      display: flex;
      justify-content: flex-start;
      align-items: center;
      border-radius: 10px 10px 0 0;
      border-bottom: 2px solid $neutralLightest;

      &__actions {
        margin-left: auto;
        justify-self: flex-end;
        display: flex;
        justify-content: flex-end;
        align-items: center;
      }

    }

    &-title {
      color: #000;
      font-size: 20px;
      font-family: $firaSans;
    }

    &-body {
      padding: 15px 20px 0 20px;
    }

  }

  .action {

    &-confirm {
      padding: 5px;
      border-radius: 20px;
      color: $primary;
      transition: background ease-in-out .2s;

      &:hover {
        color: $primaryDark;
        cursor: pointer;
      }

    }

    &-cancel {
      padding: 5px;
      margin-right: -7px;
      color: $secondary;
      transition: color ease-in-out .2s,
        background ease-in-out .2s;

      &:hover {
        color: $secondaryDark;
        cursor: pointer;
      }

    }

    &-edit {
      padding: 6px;
      margin-right: -7px;
      color: $neutralDark;
      transition: color ease-in-out .2s,
        background ease-in-out .2s;

      &:hover {
        color: $primary;
        cursor: pointer;
      }

    }

    &-delete {
      padding: 6px;
      margin-right: -7px;
      color: $neutralDark;
      transition: color ease-in-out .2s,
        background ease-in-out .2s;

      &:hover {
        color: $secondary;
        cursor: pointer;
      }

    }

  }

}
</style>
